from dune.perftool.generation import (backend,
                                      kernel_cached,
                                      valuearg)
from dune.perftool.pdelab.argument import CoefficientAccess
from dune.perftool.blockstructured.tools import micro_index_to_macro_index
from loopy.types import NumpyType
import pymbolic.primitives as prim


# TODO remove the need for element
@kernel_cached
@backend(interface="pymbolic_coefficient", name="blockstructured")
def pymbolic_coefficient(container, lfs, element, index):
    # TODO introduce a proper type for local function spaces!
    if isinstance(lfs, str):
        valuearg(lfs, dtype=NumpyType("str"))

    # If the LFS is not yet a pymbolic expression, make it one
    if not isinstance(lfs, prim.Expression):
        lfs = prim.Variable(lfs)

    # use higher order FEM index instead of Q1 index
    return prim.Call(CoefficientAccess(container), (lfs, micro_index_to_macro_index(element, index),))
