""" A helper transformation that makes all groups conflicting """

from dune.perftool.options import get_form_option


def make_groups_conflicting(knl):
    # As this transformation introduces a performance bug that basically
    # kills our CI, we only apply it if really needed - meaning in production.
    if get_form_option("assure_statement_ordering"):
        groups = frozenset().union(*tuple(i.groups for i in knl.instructions))
        return knl.copy(instructions=[i.copy(conflicts_with_groups=groups - i.groups) for i in knl.instructions])
    else:
        return knl
