from dune.perftool.generation import (backend,
                                      get_backend,
                                      generator_factory,
                                      )


@backend(interface="foo", name="f1")
@generator_factory()
def f1():
    return 1


@generator_factory()
@backend(interface="foo", name="f2")
def f2():
    return 2


@backend(interface="bar", name="f3")
@generator_factory()
def f3():
    return 3


@generator_factory()
@backend(interface="bar", name="f4")
def f4():
    return 4


def test_backend():
    assert get_backend(interface="foo", selector=lambda: "f1")() == 1
    assert get_backend(interface="foo", selector=lambda: "f2")() == 2
    assert get_backend(interface="bar", selector=lambda: "f3")() == 3
    assert get_backend(interface="bar", selector=lambda: "f4")() == 4
